static int SecureFlag = 1;


int IsAddrValid(unsigned long addr)
{
	unsigned long tmp;
	if (SecureFlag == 0) return 1;
	
	tmp = addr >> 29;
	if (tmp > 0 && tmp < 4) return 0;	/* 2xxxxxxx - 7xxxxxxx */
	if (tmp > 5) return 0;	/* cxxxxxxx - fxxxxxxx */
	
	tmp = addr & 0x1fffffff;
	if (tmp < 0x00200000) return 1;							/* RAM */
	if (tmp >= 0x1f000000 && tmp < 0x1f080000) return 1;	/* CART. */
	if (tmp >= 0x1f800000 && tmp < 0x1f800400) {
		if (addr >= 0xbf800000) return 0;	/* _݂ */
		return 1;	/* SCRATCH */
	}
	if (tmp >= 0x1fc00000 && tmp < 0x1fd00000) return 1;	/* BIOS */
	
	return 0;
}

void IgnoreAddrCheck(void) { SecureFlag = 0; }
void EnableAddrCheck(void) { SecureFlag = 1; }

/*
 *	AhXɑ΂ZBLȃAhXԂB
 *	pageSize ͈xɕ\TCYBPUiʂł 0x80AtAZʂł 48B
 */
#if 0	/* {c */
unsigned long MoveAddr(unsigned long addr, long bector, int pageSize)
{
	unsigned long tmp;
	unsigned long tmp2;
	
	tmp = (unsigned long)((long)addr + bector);
	if (IsAddrValid(tmp)) return tmp;
	tmp2 = tmp >> 29;
	tmp >>= 16;
	tmp &= 0x1fff;
	
	if (bector > 0) {
		if ((tmp & 0x1f00) != 0x1f00) tmp = 0x1f00;
		else if (tmp < 0x1f80) tmp = 0x1f80;
		else if (tmp < 0x1fc0) tmp = 0x1fc0;
		else {
			tmp = 0x0000;
			tmp2 ++;
		}
		if (tmp2 > 5) tmp2 = 0;
		else if (tmp2 > 0 && tmp2 < 4) tmp2 = 4;
		
		tmp = (tmp << 16) | (tmp2 << 29);
		if (tmp >= 0xbf800000) tmp = 0;
	} else {
		if (tmp >= 0x1fd0) {
			tmp = 0x1fd0;
		} else if (tmp >= 0x1f80) tmp = 0x1f80;
		else if (tmp >= 0x1f08) tmp = 0x1f08;
		else tmp = 0x0020;

		if (tmp2 > 5) tmp2 = 5;
		else if (tmp2 > 0 && tmp2 < 4) tmp2 = 0;

		tmp <<= 16;
		if (tmp == 0x1f800000) {
			tmp += 0x400;
			if (tmp2 == 5) tmp = 0x1f080000;
		}
		tmp |= (tmp2 << 29);
		tmp -= pageSize;
	}
	return tmp;
}
#endif	/* if 0 */

/*
 *	̂̓oOĂ邵₱̂ŁAƒx񂯂
 *	fȏB
 */
unsigned long MoveAddr(unsigned long addr, long bector, int pageSize)
{
	unsigned long tmp;
	
	tmp = (unsigned long)((long)addr + bector);
	if (IsAddrValid(tmp)) return tmp;

	/* 00000000-001fffff RAM */
	/* 1f000000-1f07ffff PAR */
	/* 1f800000-1f8003ff SCRATCH */
	/* 1fc00000-1fcfffff BIOS */
	/* 80000000-801fffff RAM */
	/* 9f000000-9f07ffff PAR */
	/* 9f800000-9f8003ff SCRATCH */
	/* 9fc00000-9fcfffff BIOS */
	/* a0000000-a01fffff RAM */
	/* bf000000-bf07ffff PAR */
	/* bfc00000-bfcfffff BIOS */

	if (bector > 0) {
		if (tmp < 0x1f000000) tmp = 0x1f000000;
		else if (tmp < 0x1f800000) tmp = 0x1f800000;
		else if (tmp < 0x1fc00000) tmp = 0x1fc00000;

		else if (tmp < 0x80000000) tmp = 0x80000000;
		else if (tmp < 0x9f000000) tmp = 0x9f000000;
		else if (tmp < 0x9f800000) tmp = 0x9f800000;
		else if (tmp < 0x9fc00000) tmp = 0x9fc00000;

		else if (tmp < 0xa0000000) tmp = 0xa0000000;
		else if (tmp < 0xbf000000) tmp = 0xbf000000;
		else if (tmp < 0xbfc00000) tmp = 0xbfc00000;
		else tmp = 0;
	} else {
		if (tmp >= 0xbfd00000) tmp = 0xbfd00000;
		else if (tmp >= 0xbf080000) tmp = 0xbf080000;
		else if (tmp >= 0xa0200000) tmp = 0xa0200000;
		else if (tmp >= 0x9fd00000) tmp = 0x9fd00000;
		else if (tmp >= 0x9f800400) tmp = 0x9f800400;
		else if (tmp >= 0x9f080000) tmp = 0x9f080000;
		else if (tmp >= 0x80200000) tmp = 0x80200000;
		else if (tmp >= 0x1fd00000) tmp = 0x1fd00000;
		else if (tmp >= 0x1fd00000) tmp = 0x1fd00000;
		else if (tmp >= 0x1f800400) tmp = 0x1f800400;
		else if (tmp >= 0x1f080000) tmp = 0x1f080000;
		else tmp = 0x00200000;
		tmp -= pageSize;
	}
	return tmp;
}


#ifdef TEST
#include <stdio.h>

int main(void)
{
	unsigned long addr;
	
	addr = 0;
	do {
		printf("addr=%08x\n", addr);
		addr = MoveAddr(addr, 0x100,0x100);
	} while (addr != 0);
	addr = 0;
	do {
		addr = MoveAddr(addr, -0x100,0x100);
		printf("addr=%08x\n", addr);
	} while (addr != 0);
	
	return 0;
}
#endif
