#ifndef _MY_TYPES_H_
#define _MY_TYPES_H_

typedef enum { false = 0, true } bool;
typedef unsigned char u_char;
typedef unsigned short u_short;
typedef unsigned long u_long;
typedef unsigned int u_int;

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned long ulong;
typedef unsigned int uint;

typedef uint	size_t;

#ifndef CHAR_BIT
#define CHAR_BIT	8
#endif

#ifndef UCHAR_MAX
#define UCHAR_MAX	255
#endif

#ifndef CHAR_MAX
#define CHAR_MAX	127
#endif

#ifndef USHRT_MAX
#define USHRT_MAX	65535
#endif

#ifndef INT_MIN
#define INT_MIN		(-2147483648)
#endif

#ifndef INT_MAX
#define INT_MAX		2147483647
#endif

#ifndef UINT_MAX
#define UINT_MAX	4294967295
#endif

#ifndef LONG_MIN
#define LONG_MIN	(-2147483648)
#endif

#ifndef LONG_MAX
#define LONG_MAX	2147483647
#endif

#ifndef ULONG_MAX
#define ULONG_MAX	4294967295
#endif

#ifndef WORD_BIT
#define	WORD_BIT	32
#endif

#ifndef NULL
#define NULL ( (void *)0 )
#endif /* NULL */

typedef struct {
	short x;
	short y;
	short w;
	short h;
} RECT;

typedef unsigned long RGB24;
#define MKRGB24(r,g,b) ( ((b) << 16) | ((g) << 8) | (r) )
#define MKRGB15(r,g,b) (	\
	(((b) >> 3) << 10) |	\
	(((g) >> 3) << 5) |	\
	((r) >> 3)		\
)
#define RGB24to15(rgb) (			\
	((0x1f & ((rgb) >> 19)) << 10) |	\
	((0x1f & ((rgb) >> 11)) << 5) |		\
	(0x1f & ((rgb) >> 3))			\
)



#define MKSHORT_YX(y,x) ( (y) << 16 | (x) )
#define MKSHORT_HW(h,w) ( (h) << 16 | (w) )

/*
 *	Function Prototypes
 */
#ifndef USE_LOWLEVEL_PAD
/* syscall ̃pbh̃`FbN */

#define PADIS_DUALSHOCK(buf) ((buf[1] & 0x53) == 0x53)

#define PADIS_UP(buf)		( buf[2] & 0x10 ? false : true )
#define PADIS_RIGHT(buf)	( buf[2] & 0x20 ? false : true )
#define PADIS_DOWN(buf)		( buf[2] & 0x40 ? false : true )
#define PADIS_LEFT(buf)		( buf[2] & 0x80 ? false : true )

#define PADIS_SELECT(buf)	( buf[2] & 0x01 ? false : true )
#define PADIS_ANALOG_L(buf)	( buf[2] & 0x02 ? false : true )
#define PADIS_ANALOG_R(buf)	( buf[2] & 0x04 ? false : true )
#define PADIS_START(buf)	( buf[2] & 0x08 ? false : true )

#define PADIS_L2(buf)		( buf[3] & 0x01 ? false : true )
#define PADIS_R2(buf)		( buf[3] & 0x02 ? false : true )
#define PADIS_L1(buf)		( buf[3] & 0x04 ? false : true )
#define PADIS_R1(buf)		( buf[3] & 0x08 ? false : true )

#define PADIS_TRIANGLE(buf)	( buf[3] & 0x10 ? false : true )
#define PADIS_CIRCLE(buf)	( buf[3] & 0x20 ? false : true )
#define PADIS_CROSS(buf)	( buf[3] & 0x40 ? false : true )
#define PADIS_SQUARE(buf)	( buf[3] & 0x80 ? false : true )


#define PAD_ANALOG_L_H(buf)	( PADIS_DUALSHOCK(buf) ? (int)(signed char)buf[6] : 0 )
#define PAD_ANALOG_L_V(buf)	( PADIS_DUALSHOCK(buf) ? (int)(signed char)buf[7] : 0 )
#define PAD_ANALOG_R_H(buf)	( PADIS_DUALSHOCK(buf) ? (int)(signed char)buf[4] : 0 )
#define PAD_ANALOG_R_V(buf)	( PADIS_DUALSHOCK(buf) ? (int)(signed char)buf[5] : 0 )

#define PADIS_ALLBUTTON_OFF(buf) ( buf[2] == 0xff && buf[3] == 0xff )

#else /* USE_LOWLEVEL_PAD */
/* foCX̏ꍇ */
/*** pad.s TNX biTmASTER ***/
void init_pad(void);
/* [ */
int get_pad(uchar *dest, int vib);	/* AiO擾̂߁APOoCg܂ */
#define DONT_VIB	0
#define DO_VIB		0x41

#define PADIS_DUALSHOCK(buf) ((buf[1] & 0x53) == 0x53)

#define PADIS_UP(buf)		( buf[3] & 0x10 ? false : true )
#define PADIS_RIGHT(buf)	( buf[3] & 0x20 ? false : true )
#define PADIS_DOWN(buf)		( buf[3] & 0x40 ? false : true )
#define PADIS_LEFT(buf)		( buf[3] & 0x80 ? false : true )

#define PADIS_SELECT(buf)	( buf[3] & 0x01 ? false : true )
#define PADIS_ANALOG_L(buf)	( buf[3] & 0x02 ? false : true )
#define PADIS_ANALOG_R(buf)	( buf[3] & 0x04 ? false : true )
#define PADIS_START(buf)	( buf[3] & 0x08 ? false : true )

#define PADIS_L2(buf)		( buf[4] & 0x01 ? false : true )
#define PADIS_R2(buf)		( buf[4] & 0x02 ? false : true )
#define PADIS_L1(buf)		( buf[4] & 0x04 ? false : true )
#define PADIS_R1(buf)		( buf[4] & 0x08 ? false : true )

#define PADIS_TRIANGLE(buf)	( buf[4] & 0x10 ? false : true )
#define PADIS_CIRCLE(buf)	( buf[4] & 0x20 ? false : true )
#define PADIS_CROSS(buf)	( buf[4] & 0x40 ? false : true )
#define PADIS_SQUARE(buf)	( buf[4] & 0x80 ? false : true )


#define PAD_ANALOG_L_H(buf)	( PADIS_DUALSHOCK(buf) ? (int)(signed char)buf[7] : 0 )
#define PAD_ANALOG_L_V(buf)	( PADIS_DUALSHOCK(buf) ? (int)(signed char)buf[8] : 0 )
#define PAD_ANALOG_R_H(buf)	( PADIS_DUALSHOCK(buf) ? (int)(signed char)buf[5] : 0 )
#define PAD_ANALOG_R_V(buf)	( PADIS_DUALSHOCK(buf) ? (int)(signed char)buf[6] : 0 )

#define PADIS_ALLBUTTON_OFF(buf) ( buf[3] == 0xff && buf[4] == 0xff )

#endif /* USE_LOWLEVEL_PAD */

#define IS_SCEE() (*(uchar *)0xbfc7ff52 == 'E')

#endif /* _MY_TYPES_H_ */
